scala.tools.nsc.Global

# icodes

###
Related Doc: package Global

#### object icodes extends ICodes

ICode generator

Source
  Global.scala

Linear Supertypes
ICodes, Repository, Printers, Linearizers, Primitives, ExceptionHandlers, TypeKinds, TypeStacks, Opcodes, BasicBlocks, Members, AnyRef, Any
Content Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. icodes
2. ICodes
3. Repository
4. Printers
5. Linearizers
6. Primitives
7. ExceptionHandlers
8. TypeKinds
9. TypeStacks
10. Opcodes
11. BasicBlocks
12. Members
13. AnyRef
14. Any

1. Hide All
2. Show all

Visibility

1. Public
2. All

### Type Members

1. #### final case class ARRAY (elem: ICodes.TypeKind) extends ICodes.TypeKind with Product with Serializable

   Definition Classes
     TypeKinds

2. #### case class Arithmetic (op: ICodes.ArithmeticOp, kind: ICodes.TypeKind) extends ICodes.Primitive with Product with Serializable

   Definition Classes
     Primitives

3. #### class ArithmeticOp extends AnyRef

   This class represents an arithmetic operation.

   This class represents an arithmetic operation.

   Definition Classes
     Primitives

4. #### case class ArrayLength (kind: ICodes.TypeKind) extends ICodes.Primitive with Product with Serializable

   Definition Classes
     Primitives

5. #### case class BOXED (kind: ICodes.TypeKind) extends ICodes.TypeKind with Product with Serializable

   A boxed value.

   A boxed value.

   Definition Classes
     TypeKinds

6. #### class BasicBlock extends ProgramPoint[ICodes.BasicBlock]

   This class represents a basic block.

   This class represents a basic block. Each basic block contains a list of instructions that are either executed all, or none. No jumps to/from the "middle" of the basic block are allowed (modulo exceptions).

   Definition Classes
     BasicBlocks

7. #### class Code extends AnyRef

   This class represents the intermediate code of a method or other multi-block piece of code, like exception handlers.

   This class represents the intermediate code of a method or other multi-block piece of code, like exception handlers.

   Definition Classes
     Members

8. #### case class Comparison (op: ICodes.ComparisonOp, kind: ICodes.TypeKind) extends ICodes.Primitive with Product with Serializable

   Definition Classes
     Primitives

9. #### class ComparisonOp extends AnyRef

   This class represents a comparison operation.

   This class represents a comparison operation.

   Definition Classes
     Primitives

10. #### case class Conversion (src: ICodes.TypeKind, dst: ICodes.TypeKind) extends ICodes.Primitive with Product with Serializable

    Definition Classes
      Primitives

11. #### class DepthFirstLinerizer extends ICodes.Linearizer

    Linearize code using a depth first traversal.

    Linearize code using a depth first traversal.

    Definition Classes
      Linearizers

12. #### class DumpLinearizer extends ICodes.Linearizer

    A 'dump' of the blocks in this method, which does not require any well-formedness of the basic blocks (like the last instruction being a jump).

    A 'dump' of the blocks in this method, which does not require any well-formedness of the basic blocks (like the last instruction being a jump).

    Definition Classes
      Linearizers

13. #### class ExceptionHandler extends AnyRef

    Definition Classes
      ExceptionHandlers

14. #### class Finalizer extends ICodes.ExceptionHandler

    Definition Classes
      ExceptionHandlers

15. #### class IClass extends ICodes.IMember

    Represent a class in ICode

    Represent a class in ICode

    Definition Classes
      Members

16. #### abstract class ICodePhase extends GlobalPhase

    A phase which works on icode.

    A phase which works on icode.

    Definition Classes
      ICodes

17. #### class IField extends ICodes.IMember

    Represent a field in ICode

    Represent a field in ICode

    Definition Classes
      Members

18. #### trait IMember extends Ordered[ICodes.IMember]

    Common interface for IClass/IField/IMethod.

    Common interface for IClass/IField/IMethod.

    Definition Classes
      Members

19. #### class IMethod extends ICodes.IMember

    Represents a method in ICode.

    Represents a method in ICode. Local variables contain both locals and parameters, similar to the way the JVM 'sees' them.

    Locals and parameters are added in reverse order, as they are kept in cons-lists. The 'builder' is responsible for reversing them and putting them back, when the generation is finished (GenICode does that).

    Definition Classes
      Members

20. #### abstract class Instruction extends Cloneable

    This class represents an instruction of the intermediate code.

    This class represents an instruction of the intermediate code. Each case subclass will represent a specific operation.

    Definition Classes
      Opcodes

21. #### abstract class Linearizer extends AnyRef

    Definition Classes
      Linearizers

22. #### class Local extends AnyRef

    Represent local variables and parameters

    Represent local variables and parameters

    Definition Classes
      Members

23. #### case class Logical (op: ICodes.LogicalOp, kind: ICodes.TypeKind) extends ICodes.Primitive with Product with Serializable

    Definition Classes
      Primitives

24. #### class LogicalOp extends AnyRef

    This class represents a logical operation.

    This class represents a logical operation.

    Definition Classes
      Primitives

25. #### case class Negation (kind: ICodes.TypeKind) extends ICodes.Primitive with Product with Serializable

    Definition Classes
      Primitives

26. #### class NormalLinearizer extends ICodes.Linearizer with WorklistAlgorithm

    A simple linearizer which predicts all branches to take the 'success' branch and tries to schedule those blocks immediately after the test.

    A simple linearizer which predicts all branches to take the 'success' branch and tries to schedule those blocks immediately after the test. This is in sync with how 'while' statements are translated (if the test is 'true', the loop continues).

    Definition Classes
      Linearizers

27. #### class Primitive extends AnyRef

    This class represents a primitive operation.

    This class represents a primitive operation.

    Definition Classes
      Primitives

28. #### class PrimitivePrinter extends AnyRef

    Pretty printer for primitives

    Pretty printer for primitives

    Definition Classes
      Primitives

29. #### final case class REFERENCE (cls: Global.Symbol) extends ICodes.TypeKind with Product with Serializable

    A class type.

    A class type.

    Definition Classes
      TypeKinds

30. #### type Rep = collection.immutable.List[TypeKind]

    Definition Classes
      TypeStacks

31. #### class ReversePostOrderLinearizer extends ICodes.Linearizer

    Linearize code in reverse post order.

    Linearize code in reverse post order. In fact, it does a post order traversal, prepending visited nodes to the list. This way, it is constructed already in reverse post order.

    Definition Classes
      Linearizers

32. #### case class Shift (op: ICodes.ShiftOp, kind: ICodes.TypeKind) extends ICodes.Primitive with Product with Serializable

    Definition Classes
      Primitives

33. #### class ShiftOp extends AnyRef

    This class represents a shift operation.

    This class represents a shift operation.

    Definition Classes
      Primitives

34. #### case class StringConcat (el: ICodes.TypeKind) extends ICodes.Primitive with Product with Serializable

    Definition Classes
      Primitives

35. #### case class Test (op: ICodes.TestOp, kind: ICodes.TypeKind, zero: Boolean) extends ICodes.Primitive with Product with Serializable

    Definition Classes
      Primitives

36. #### sealed abstract class TestOp extends AnyRef

    This class represents a test operation.

    This class represents a test operation.

    Definition Classes
      Primitives

37. #### class TextPrinter extends AnyRef

    Definition Classes
      Printers

38. #### sealed abstract class TypeKind extends AnyRef

    This class represents a type kind.

    This class represents a type kind. Type kinds represent the types that the VM know (or the ICode view of what VMs know).

    Definition Classes
      TypeKinds

39. #### class TypeStack extends AnyRef

    Definition Classes
      TypeStacks

40. #### sealed abstract class ValueTypeKind extends ICodes.TypeKind

    Definition Classes
      TypeKinds

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

4. #### object ADD extends ICodes.ArithmeticOp with Product with Serializable

   An arithmetic addition operation

   An arithmetic addition operation

   Definition Classes
     Primitives

5. #### object AND extends ICodes.LogicalOp with Product with Serializable

   A bitwise AND operation

   A bitwise AND operation

   Definition Classes
     Primitives

6. #### object ASR extends ICodes.ShiftOp with Product with Serializable

   An arithmetic shift to the right

   An arithmetic shift to the right

   Definition Classes
     Primitives

7. #### lazy val AnyRefReference: TypeKind

   Definition Classes
     ICodes

8. #### def ArrayN(elem: TypeKind, dims: Int): ARRAY

   Definition Classes
     TypeKinds

9. #### object BOOL extends ICodes.ValueTypeKind with Product with Serializable

   A boolean value

   A boolean value

   Definition Classes
     TypeKinds

10. #### object BYTE extends ICodes.ValueTypeKind with Product with Serializable

    A 1-byte signed integer

    A 1-byte signed integer

    Definition Classes
      TypeKinds

11. #### lazy val BoxedUnitReference: TypeKind

    Definition Classes
      ICodes

12. #### object CHAR extends ICodes.ValueTypeKind with Product with Serializable

    A 2-byte UNSIGNED integer

    A 2-byte UNSIGNED integer

    Definition Classes
      TypeKinds

13. #### object CMP extends ICodes.ComparisonOp with Product with Serializable

    A comparison operation with no default for NaNs

    A comparison operation with no default for NaNs

    Definition Classes
      Primitives

14. #### object CMPG extends ICodes.ComparisonOp with Product with Serializable

    A comparison operation with +1 default for NaNs

    A comparison operation with +1 default for NaNs

    Definition Classes
      Primitives

15. #### object CMPL extends ICodes.ComparisonOp with Product with Serializable

    A comparison operation with -1 default for NaNs

    A comparison operation with -1 default for NaNs

    Definition Classes
      Primitives

16. #### object ConcatClass extends ICodes.TypeKind with Product with Serializable

    Dummy TypeKind to represent the ConcatClass in a platform-independent way.

    Dummy TypeKind to represent the ConcatClass in a platform-independent way. For JVM it would have been a REFERENCE to 'StringBuffer'.

    Definition Classes
      TypeKinds

17. #### object DIV extends ICodes.ArithmeticOp with Product with Serializable

    An arithmetic division operation

    An arithmetic division operation

    Definition Classes
      Primitives

18. #### object DOUBLE extends ICodes.ValueTypeKind with Product with Serializable

    An 8-byte floating point number

    An 8-byte floating point number

    Definition Classes
      TypeKinds

19. #### object EQ extends ICodes.TestOp with Product with Serializable

    An equality test

    An equality test

    Definition Classes
      Primitives

20. #### object EndConcat extends ICodes.Primitive with Product with Serializable

    type: (buf) => STR jvm : It should turn the StringBuffer into a String.

    type: (buf) => STR jvm : It should turn the StringBuffer into a String.

    Definition Classes
      Primitives

21. #### object FLOAT extends ICodes.ValueTypeKind with Product with Serializable

    A 4-byte floating point number

    A 4-byte floating point number

    Definition Classes
      TypeKinds

22. #### object GE extends ICodes.TestOp with Product with Serializable

    A greater-than-or-equal test

    A greater-than-or-equal test

    Definition Classes
      Primitives

23. #### object GT extends ICodes.TestOp with Product with Serializable

    A greater-than test

    A greater-than test

    Definition Classes
      Primitives

24. #### object INT extends ICodes.ValueTypeKind with Product with Serializable

    A 4-byte signed integer

    A 4-byte signed integer

    Definition Classes
      TypeKinds

25. #### object LE extends ICodes.TestOp with Product with Serializable

    A less-than-or-equal test

    A less-than-or-equal test

    Definition Classes
      Primitives

26. #### object LONG extends ICodes.ValueTypeKind with Product with Serializable

    An 8-byte signed integer

    An 8-byte signed integer

    Definition Classes
      TypeKinds

27. #### object LSL extends ICodes.ShiftOp with Product with Serializable

    A logical shift to the left

    A logical shift to the left

    Definition Classes
      Primitives

28. #### object LSR extends ICodes.ShiftOp with Product with Serializable

    A logical shift to the right

    A logical shift to the right

    Definition Classes
      Primitives

29. #### object LT extends ICodes.TestOp with Product with Serializable

    A less-than test

    A less-than test

    Definition Classes
      Primitives

30. #### object MUL extends ICodes.ArithmeticOp with Product with Serializable

    An arithmetic multiplication operation

    An arithmetic multiplication operation

    Definition Classes
      Primitives

31. #### object NE extends ICodes.TestOp with Product with Serializable

    A non-equality test

    A non-equality test

    Definition Classes
      Primitives

32. #### object NOT extends ICodes.ArithmeticOp with Product with Serializable

    Bitwise negation.

    Bitwise negation.

    Definition Classes
      Primitives

33. #### object NoBasicBlock extends ICodes.BasicBlock

    Definition Classes
      BasicBlocks

34. #### object NoCode extends ICodes.Code

    Definition Classes
      Members

35. #### object NoIMethod extends ICodes.IMethod

    Definition Classes
      Members

36. #### lazy val NothingReference: TypeKind

    Definition Classes
      ICodes

37. #### lazy val NullReference: TypeKind

    Definition Classes
      ICodes

38. #### object OR extends ICodes.LogicalOp with Product with Serializable

    A bitwise OR operation

    A bitwise OR operation

    Definition Classes
      Primitives

39. #### lazy val ObjectReference: TypeKind

    Definition Classes
      ICodes

40. #### object REM extends ICodes.ArithmeticOp with Product with Serializable

    An arithmetic remainder operation

    An arithmetic remainder operation

    Definition Classes
      Primitives

41. #### object SHORT extends ICodes.ValueTypeKind with Product with Serializable

    A 2-byte signed integer

    A 2-byte signed integer

    Definition Classes
      TypeKinds

42. #### object SUB extends ICodes.ArithmeticOp with Product with Serializable

    An arithmetic subtraction operation

    An arithmetic subtraction operation

    Definition Classes
      Primitives

43. #### object StartConcat extends ICodes.Primitive with Product with Serializable

    Signals the beginning of a series of concatenations.

    Signals the beginning of a series of concatenations. On the JVM platform, it should create a new StringBuffer

    Definition Classes
      Primitives

44. #### lazy val StringReference: TypeKind

    Definition Classes
      ICodes

45. #### object UNIT extends ICodes.ValueTypeKind with Product with Serializable

    The unit value

    The unit value

    Definition Classes
      TypeKinds

46. #### object XOR extends ICodes.LogicalOp with Product with Serializable

    A bitwise XOR operation

    A bitwise XOR operation

    Definition Classes
      Primitives

47. #### final val arilogCat: Int(4)

    Definition Classes
      Opcodes

48. #### final val arraysCat: Int(9)

    Definition Classes
      Opcodes

49. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

50. #### def available(sym: Global.Symbol): Boolean

    Is the given class available as icode?

    Is the given class available as icode?

    Definition Classes
      Repository

51. #### final val castsCat: Int(5)

    Definition Classes
      Opcodes

52. #### def checkValid(m: IMethod): Unit

    Definition Classes
      ICodes

53. #### def checkerDebug(msg: String): Unit

    Definition Classes
      ICodes

54. #### val classes: HashMap[Global.Symbol, IClass]

    The ICode representation of classes

    The ICode representation of classes

    Definition Classes
      ICodes

55. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

56. #### final val constCat: Int(3)

    Definition Classes
      Opcodes

57. #### def dumpClassesAndAbort(msg: String): Nothing

    Print all classes and basic blocks.

    Print all classes and basic blocks. Used for debugging.

    Definition Classes
      ICodes

58. #### def dumpMethodAndAbort(m: IMethod, b: BasicBlock): Nothing

    Definition Classes
      ICodes

59. #### def dumpMethodAndAbort(m: IMethod, msg: String): Nothing

    Definition Classes
      ICodes

60. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

61. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

62. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

63. #### final val fldsCat: Int(7)

    Definition Classes
      Opcodes

64. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

65. #### val global: Global.this.type

    Definition Classes
      icodes → ICodes → Repository

66. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

67. #### def icode(sym: Global.Symbol): Option[IClass]

    The icode of the given class, if available

    The icode of the given class, if available

    Definition Classes
      Repository

68. #### object icodeReader extends ICodeReader

    Definition Classes
      ICodes

69. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

70. #### final val jumpsCat: Int(10)

    Definition Classes
      Opcodes

71. #### val linearizer: Linearizer

    The ICode linearizer.

    The ICode linearizer.

    Definition Classes
      ICodes

72. #### object liveness extends Liveness

    Definition Classes
      ICodes

73. #### def load(sym: Global.Symbol): Boolean

    Load bytecode for given symbol.

    Load bytecode for given symbol.

    Definition Classes
      Repository

74. #### val loaded: Map[Global.Symbol, IClass]

    Definition Classes
      Repository

75. #### final val localsCat: Int(1)

    Definition Classes
      Opcodes

76. #### def lub(a: TypeKind, b: TypeKind): TypeKind

    The least upper bound of two typekinds.

    The least upper bound of two typekinds. They have to be either REFERENCE or ARRAY kinds.

    The lub is based on the lub of scala types.

    Definition Classes
      TypeKinds

77. #### final val mthdsCat: Int(8)

    Definition Classes
      Opcodes

78. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

79. #### def newTextPrinter(): TextPrinter

    Definition Classes
      ICodes

80. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

81. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

82. #### final val objsCat: Int(6)

    Definition Classes
      Opcodes

83. #### object opcodes

    Definition Classes
      Opcodes

84. #### lazy val primitiveTypeMap: Map[Global.Symbol, TypeKind]

    A map from scala primitive Types to ICode TypeKinds

    A map from scala primitive Types to ICode TypeKinds

    Definition Classes
      TypeKinds

85. #### object reachingDefinitions extends ReachingDefinitions

    Definition Classes
      ICodes

86. #### final val retCat: Int(11)

    Definition Classes
      Opcodes

87. #### def shouldCheckIcode: Boolean

    Debugging flag

    Debugging flag

    Definition Classes
      ICodes

88. #### final val stackCat: Int(2)

    Definition Classes
      Opcodes

89. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

90. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

91. #### def toTypeKind(t: Global.Type): TypeKind

    Return the TypeKind of the given type

    Return the TypeKind of the given type

    Call to dealiasWiden fixes #3003 (follow type aliases). Otherwise, arrayOrClassType below would return ObjectReference.

    Definition Classes
      TypeKinds

92. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

93. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

94. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

### Inherited from ICodes

### Inherited from Repository

### Inherited from Printers

### Inherited from Linearizers

### Inherited from Primitives

### Inherited from ExceptionHandlers

### Inherited from TypeKinds

### Inherited from TypeStacks

### Inherited from Opcodes

### Inherited from BasicBlocks

### Inherited from Members

### Inherited from AnyRef

### Inherited from Any

### Ungrouped